<template>
  <div class="product-item">
    <div class="product-image">
      <img :src="grid_img" :alt="title" />
      <label
        :for="`product-like-${id}`"
        class="product-fav"
        aria-label="Добавить в избранное"
      >
        <input
          :id="`product-like-${id}`"
          :checked="reactions.like"
          type="checkbox"
          @click.prevent="() => onSave(id)"
        />
        <i class="icon-like"></i>
      </label>
    </div>
    <div class="d-flex align-items-start justify-content-between">
      <div class="product-title">{{ name }}</div>
      <div class="product-rating">
        <i class="icon-star_full"></i>
        <span>{{ saved_number }}</span>
      </div>
    </div>
    <div class="product-except">{{ description }}</div>
    <div
      class="product-info d-flex align-items-center justify-content-between mt-3"
    >
      <div class="product-rate">
        <base-rating
          :id="id"
          editable
          :rating="reactions.star"
          @change="(rate) => onRate(rate, id)"
        />
      </div>
      <div class="product-comment-count">
        <i class="icon-comment"></i>
        <span>{{ comments_number }}</span>
      </div>
    </div>
    <nuxt-link :to="`/showroom/${slug}`" class="stretched-link"></nuxt-link>
  </div>
</template>

<script>
import { reactions } from '@/mixins/product'
export default {
  name: 'ProductCard',
  /** @type {Showroom} */
  mixins: [reactions],
  props: {
    // eslint-disable-next-line vue/prop-name-casing
    grid_img: {
      type: String,
      required: false,
      default: '',
    },
    // eslint-disable-next-line vue/prop-name-casing
    average_star: {
      type: [String, Number],
      required: false,
      default: 0,
    },
    // eslint-disable-next-line vue/prop-name-casing
    comments_number: {
      type: [String, Number],
      required: false,
      default: 0,
    },
    // eslint-disable-next-line vue/prop-name-casing
    saved_number: {
      type: [String, Number],
      required: false,
      default: 0,
    },
    // eslint-disable-next-line vue/prop-name-casing
    saved_user: {
      type: Boolean,
      required: true,
    },
    // eslint-disable-next-line vue/prop-name-casing
    user_star: {
      type: Number,
      required: false,
      default: null,
    },
    name: {
      type: String,
      required: true,
      default: '',
    },
    title: {
      type: String,
      required: false,
      default: '',
    },
    description: {
      type: String,
      required: false,
      default: '',
    },
    id: {
      type: [String, Number],
      required: true,
    },
    slug: {
      type: String,
      required: true,
    },
  },
  computed: {
    reactions() {
      const product = this.$store.state.products[this.id]
      return {
        star: product.user_star,
        like: product.saved_user,
      }
    },
  },
}
</script>
